/**
 * @file
 * quartiers_de_demain behaviors.
 */
 (function (Drupal) {

    'use strict';
  
    Drupal.behaviors.quartiers_de_demain = {
      attach: function (context, settings) {
        console.log('It works!');
      }
    };
  } (Drupal));

  
  // jQuery(document).ready(function($){

  //   $('.open-block').click(function(){
  //     $(this).toggleClass('opened');

  //     $('.header_nav_container').toggleClass('display-nav-opened');
    
  //     if(mobile == true){
  //       $("body").css("overflow","hidden");
  //     }

  //   });
  
  //   // Hide the header_nav_container when a link inside it is clicked
  //   $('.header_nav_container li').click(function() {
  //       $('.header_nav_container').fadeOut();
  //   });




  // });

  //////// start header ////////////
  document.addEventListener('DOMContentLoaded', function() {

    const header = document.querySelector('header');
    const logo = document.querySelector('#block-quartiers-de-demain-logoquartiersdedemain > div:nth-child(1) > div:nth-child(1) > a:nth-child(1) > svg:nth-child(1)');
    const headerNavContainer = document.querySelector('.header_nav_container');
    const isFirstLoad = !performance.getEntriesByType("navigation")[0].type.includes('back_forward');
    const isTargetPath = window.location.pathname === '/';

    // Fonction pour démarrer l'animation du logo SVG
    function startLogoAnimation() {
      logo.classList.add('animated');
    }
  
    // Fonction pour arrêter l'animation du logo SVG
    function stopLogoAnimation() {
      logo.classList.remove('animated');
    }
  
    // Vérifier si le header a la classe header--collapse
    function checkHeaderCollapse() {
      if (header.classList.contains('header--collapsed')) {
        stopLogoAnimation();
      } else if (header.classList.contains('header--collapsed-already'))  {
          stopLogoAnimation();
        } else {
        startLogoAnimation();
      }

    }
  
    // Appeler la fonction au chargement initial
    checkHeaderCollapse();
  
    // Observer les changements de classe sur le header
    const observer = new MutationObserver(function(mutations) {
      mutations.forEach(function(mutation) {
        if (mutation.attributeName === 'class') {
          checkHeaderCollapse();
        }
      });
    });
    observer.observe(header, { attributes: true });
 

    // Si ce n'est pas la première charge ou si le chemin n'est pas le chemin cible, ajouter la classe immédiatement
    if (!isFirstLoad || !isTargetPath) {
      header.classList.add('header--collapsed-already');
      // logo.classList.remove('animated');
      stopLogoAnimation();
    } else {
      // Sinon, appliquer la transition après un délai
      setTimeout(() => {
          header.classList.add('header--collapsed');
      }, 5000);
    }

    //////////////////////////////////////

    let lastScrollTop = 0;
    let threshold = 100; // Change this value as needed
    let isHidden = false;
  
    function slideOut() {
      headerNavContainer.animate([
        { transform: 'translateX(0)' },
        { transform: 'translateX(-100%)' }
      ], {
        duration: 300,
        fill: 'forwards'
      });
      isHidden = true;
    }
  
    function slideIn() {
      headerNavContainer.animate([
        { transform: 'translateX(-100%)' },
        { transform: 'translateX(0)' }
      ], {
        duration: 300,
        fill: 'forwards'
      });
      isHidden = false;
    }
    
    function slideDown() {
      // headerNavContainer.style.display = 'block';
      headerNavContainer.animate([
        { transform: 'translateY(0%)' },
        { transform: 'translateY(+100%)' }
      ], {
        duration: 300,
        fill: 'forwards'
      });
      isHidden = false;
    }
  
    function slideUp() {
      headerNavContainer.animate([
        { transform: 'translateY(100%)' },
        { transform: 'translateY(0%)' }
      ], {
        duration: 300,
        fill: 'forwards'
      }).onfinish = function() {
        // headerNavContainer.style.display = 'none';
      };
      isHidden = true;
    }
      // Fonction pour ajuster la hauteur du header lors du défilement
      function adjustHeaderHeight() {
        if (window.scrollY > 0) {
          header.classList.add('shrink');
        } else {
          header.classList.remove('shrink');
        }
      }

    function handleScroll() {
      let scrollTop = window.pageYOffset || document.documentElement.scrollTop;
      const isMobile = window.innerWidth < 811;

      if (scrollTop > threshold && !isHidden) {
        if (isMobile) {
          slideUp();
        } else {
          slideOut();
        }
      } else if (scrollTop <= threshold && isHidden) {
        if (isMobile) {
          slideDown();
        } else {
          slideIn();
        }
      }
  
  
      lastScrollTop = scrollTop <= 0 ? 0 : scrollTop; // For Mobile or negative scrolling
    }
  
    function handleTouchAndMouseEnter() {
      if (isHidden) {
        if (window.innerWidth < 811) {
          slideDown();
        } else {
          slideIn();
        }
      }
    }
  
    function handleTouchAndMouseLeave() {
      if (lastScrollTop > threshold && !isHidden) {
        if (window.innerWidth < 811) {
          slideUp();
        } else {
          slideOut();
        }
      }
    }
  
    window.addEventListener('scroll', handleScroll);
    window.addEventListener('scroll', adjustHeaderHeight);
  
    // Mouse events for desktop
    header.addEventListener('mouseenter', handleTouchAndMouseEnter);
    header.addEventListener('mouseleave', handleTouchAndMouseLeave);
  
    // Touch events for tablets and mobile devices
    header.addEventListener('touchstart', handleTouchAndMouseEnter);
    header.addEventListener('touchend', handleTouchAndMouseLeave);
  
    // Initial check to see if we're at the top of the page
    if (window.pageYOffset <= threshold) {
      if (window.innerWidth < 811) {
        slideDown();
      } else { 
        slideIn();
      } 
    } else {
      if (window.innerWidth < 811) {
        slideUp();
      } else {
        slideIn();
      }
    }
  
  });

  //////// end header ////////////
  


//// ancre dans texte au click parragraphe correspondant arrive en dessous du header 


(function($, window) {
  var adjustAnchor = function() {
      var $anchor = $('.sidebar_first_container'),
              fixedElementHeight = 500;
      if ($anchor.length > 0) {
          $('html, body').stop().animate({scrollTop: $anchor.offset().top - fixedElementHeight }, 0);
      }
  };

  $(window).on('hashchange', function() {
      adjustAnchor();
  });


  ////////////////////////  start script smooth apparition des textes /////////////////

  function scrollReaveal(){

    const nodes = {
      logo : document.querySelectorAll('#logo-animated-container'),
      chapeau :  document.querySelectorAll('.field_body'),
      paragraph: document.querySelectorAll('.field_field_textes .paragraph--type--static-parts'),
      enjeux : document.querySelectorAll('.field_field_textes .paragraph--type--static-parts .enjeux'),
    }

    const showUp = {
        origin: 'bottom',
        delay: 100,
        duration: 1000,
        distance: '50px',
        easing: 'cubic-bezier(0.5, 0, 0, 1)'
    }

    const Show = {
      delay: 100,
      duration: 600,
      easing: 'cubic-bezier(0.5, 0, 0, 1)'
    }

    console.log(nodes);

    ScrollReveal().reveal(nodes.logo, Show);
    ScrollReveal().reveal(nodes.chapeau, showUp);
    ScrollReveal().reveal(nodes.paragraph, showUp);
    ScrollReveal().reveal(nodes.enjeux, showUp);
  }


  $( document ).ready(function() {
    scrollReaveal();
  });

  ////////////////////////  end script smooth apparition des textes /////////////////

  // //////////////////// start Timeline script ///////////////////////


    // Update month field to only show the first 3 letters
    document.querySelectorAll('.paragraph--type--phase-deroulement').forEach(function(paragraph) {
      const monthField = paragraph.querySelector('.field_field_date_de_moi div:nth-of-type(2)');
      if (monthField) {
        const monthText = monthField.textContent.trim();
        if (monthText === "juillet") {
          monthField.textContent = monthText.slice(0, 4);
          monthField.classList.add('after');
        } else if (monthText === "juin") {
          monthField.textContent = monthText.slice(0, 4);
        } else if (monthText.length > 3) {
          monthField.textContent = monthText.slice(0, 3);
          monthField.classList.add('after');
        }
      }
    });
  
    // Fonction pour ajouter ou retirer la classe .only
    function updateDateClasses() {
      document.querySelectorAll('.paragraph--type--phase-deroulement .date').forEach(function(dateElement) {
        const date2Element = dateElement.querySelector('.date2');
        const yearElement = dateElement.querySelector('.field_field_date_de_annee');
  
        if (date2Element && !date2Element.textContent.trim()) {
          if (yearElement) {
            yearElement.classList.add('only');
          }
        } else {
          if (yearElement) {
            yearElement.classList.remove('only');
          }
        }
      });
    }
  
    // Exécuter la fonction une première fois pour le contenu déjà présent
    updateDateClasses();
  
    // MutationObserver pour surveiller les changements dans le DOM
    const observer = new MutationObserver(function(mutationsList, observer) {
      for(let mutation of mutationsList) {
        if (mutation.type === 'childList') {
          updateDateClasses();
        }
      }
    });


  //   ////////////////////// start  calendrier home   /////////////////////////////////
    $(document).ready(function(){
      $('.__timeline-content').slick({
        slidesToShow: 3,
        // slidesToScroll: 1,
        dots: false,
        arrows: true,
        centerMode: true,
        adaptiveHeight: true,
        autoplay: false,
        draggable: true,
        // autoplaySpeed: 1500,
        infinite: true,
        // centerPadding: '100px',
        responsive: [
          {
            breakpoint: 500,
            settings: {
              slidesToShow: 1,
              adaptiveHeight: false,
              arrows: true,
              draggable: true,
              centerMode: true,
              autoplay: false,
              // autoplaySpeed: 2000,
              // centerPadding: '100px',

            }
          }]
      });
      console.log('salut slick calendrier');
    
      });
    
  //       ////////////////////// end   calendrier home   /////////////////////////////////
  
  

  //////////////////////// end Timeline script /////////////////////////////////////////////

  ///////////////////  caracteres  body actus/////////////////////////

  document.addEventListener('DOMContentLoaded', function() {
    // Maximum number of characters to display
    const maxChars = 140; // Adjust this value as needed
  
    document.querySelectorAll('#actus-caroussel .node-type-actualite .field_body p').forEach(function(paragraph) {
      let text = paragraph.textContent.trim();
      if (text.length > maxChars) {
        let truncatedText = text.slice(0, maxChars) + '...';
        paragraph.textContent = truncatedText;
      }
    });
  });
  

 ////////////  slideshow home  ////////////////////////// 

  $(document).ready(function(){
      let actuview = $('.content-actus .view')
      if (actuview) {
        actuview.slick({
          slidesToShow: 3,
          // slidesToScroll: 1,
          dots: false,
          arrows: true,
          centerMode: true,
          adaptiveHeight: true,
          autoplay: false,
          // autoplaySpeed: 1500,
          // infinite: true,
          // centerPadding: '100px',
          responsive: [
            {
              breakpoint: 810,
              settings: {
                slidesToShow: 1,
                adaptiveHeight: false,
                arrows: true,
                draggable: true,
                centerMode: true,
                autoplay: false,
                // autoplaySpeed: 2000,
              }
            }]
        });
        console.log('salut slick home');
        
      }

  });
  

})(jQuery, window);


